unit helper;

interface

//{$DEFINE DO_DEBUG}

uses idhttp;

type TProgressEvent = procedure(Sender:TObject; pages,questions:integer) of object;
     TGrades=array['A'..'D'] of integer;

function getGrades(idhttp1:TIdHttp; userid:string; progress:TProgressEvent=nil):TGrades;

implementation

uses strutils, windows, wininet, sysutils {$IFDEF DO_DEBUG}, classes {$ENDIF};

function DownloadFile(const Url: string): string;
var
  NetHandle: HINTERNET;
  UrlHandle: HINTERNET;
  Buffer: array[0..1024] of Char;
  BytesRead: dWord;
begin
  Result := '';
  NetHandle := InternetOpen('Delphi 5.x', INTERNET_OPEN_TYPE_PRECONFIG, nil, nil, 0);

  if Assigned(NetHandle) then 
  begin
    UrlHandle := InternetOpenUrl(NetHandle, PChar(Url), nil, 0, INTERNET_FLAG_RELOAD, 0);

    if Assigned(UrlHandle) then
      { UrlHandle valid? Proceed with download }
    begin
      FillChar(Buffer, SizeOf(Buffer), 0);
      repeat
        Result := Result + Buffer;
        FillChar(Buffer, SizeOf(Buffer), 0);
        InternetReadFile(UrlHandle, @Buffer, SizeOf(Buffer), BytesRead);
//        application.processmessages; if not in a thread
      until BytesRead = 0;
      InternetCloseHandle(UrlHandle);
    end
    else
      { UrlHandle is not valid. Raise an exception. }
      raise Exception.CreateFmt('Cannot open URL %s', [Url]);

    InternetCloseHandle(NetHandle);
  end
  else
    { NetHandle is not valid. Raise an exception }
    raise Exception.Create('Unable to initialize Wininet');
end;

function passfilter(url:string):boolean;
begin
  result:=true;
end;

{$IFDEF DO_DEBUG}
procedure saveit(s:string);
begin
  with tfilestream.create('c:\dump',fmcreate) do
  begin
    write(pansichar(s)^,length(s));
    free;
  end;
end;
{$ENDIF}

function getGrade(idhttp1:TIdHttp; url:string):char;
var main,grade:string; p:integer;
begin
  result:=#0;
  grade:='and received a <span style="font-style:italic">grade of ';// - only if logged in
//  main:=idhttp1.get(url);
  main:=downloadfile(url);
{$IFDEF DO_DEBUG}
  saveit(main);
{$ENDIF}  
  p:=pos(grade,main);
  assert(p>0);
  if p>0 then
    result:=main[p+length(grade)];
end;

function getGrades(idhttp1:TIdHttp; userid:string; progress:TProgressEvent=nil):TGrades;
var main, url, nexturl, start, next:string;
    p, pages, questions:integer;
    hasnext:boolean;
begin
  pages:=0;
  questions:=0;
  result['A']:=0;
  result['B']:=0;
  result['C']:=0;
  result['D']:=0;
  url:='http://www.experts-exchange.com/AH_'+userid+'.html';
  nexturl:='/viewAnswerHistory.jsp?mid='+userid+'&orderBy=5&sort=-1&page=';
  start:='<td class="itemEven"><a href="/viewAnswerHistory.jsp?mid='+userid+'&orderBy=99&sort=1"><b>Topic Area</b></a></td>';
  repeat
    inc(pages);
    if assigned(progress) then
      progress(nil,pages,questions);

    main:=IdHTTP1.Get(url);

    p:=pos('">>></a>',main);
    hasnext:=p>0;
    if p>0 then
    begin
      url:='http://www.experts-exchange.com'+nexturl;
      p:=p-1;
      while main[p]<>'=' do
        dec(p);
      inc(p);
      while main[p]<>'"' do
      begin
        url:=url+main[p];
        inc(p);
      end;
      next:=url;
    end;
    p:=pos(start,main);
    delete(main,1,p+length(start));
    p:=pos(nexturl,main);
    delete(main,p-7,length(main));

    p:=pos('<a href="',main);
    repeat
      inc(questions);
      if assigned(progress) then
        progress(nil,pages,questions);
      p:=p+9;
      url:='http://www.experts-exchange.com';
      while main[p]<>'"' do
      begin
        url:=url+main[p];
        inc(p);
      end;

      if passfilter(url) then
        inc(result[getGrade(idhttp1, url)]);

      p:=posex('<a href="',main,p);
      p:=posex('<a href="',main,p+1);
    until p=0;

    if hasnext then
    begin
      url:=next;
      p:=1;
    end        else
      p:=0;
  until p=0;
end;

end.
